//NanoMSR2
#include <stdio.h>
#include <math.h>
unsigned char dds1[256];
unsigned char dds2[256];
unsigned int n, i, j, a1, a2, adn, ph1, ph2, t, f, timeout, adc;
unsigned char b, c, d, dv, dvn, duo, level, hi, lo, ds1, ds2, ch, fh1, fh2;

ISR (TIMER2_OVF_vect)
{
  PORTB |= 1;
  a1+=ph1;
  a2+=ph2;
  if (ds1) OCR2A=(dds1[a1>>8]);
  if (ds2) OCR2B=(dds2[a2>>8]);
  PORTD = (PORTD & ~128)|((a1>>8)&128);
  PORTD = (PORTD & ~16)|((a2>>11)&16);
  t++;
  if(t==0){ TCCR1B = 0x00; TCNT1=0; fh1=0;}
  if(t==1){ TCCR1B = 0x07;}
  if(t==62501){ TCCR1B = 0x00;f=TCNT1; fh2=fh1;}
  dvn++;
  if (dvn >= dv){
    if (adn<629){
       UDR0 = ADCH;
       if (duo==1) ADMUX = 0x60+(adn & 0x0001);
       adn++;
       dvn=0;
    }
  }  
  ADCSRA |= 0x40;  //AD Start  
  PORTB &= ~1;
}

ISR (TIMER1_OVF_vect)
{
  fh1++;
}

void USART_Transmit(unsigned char data){
  while ( !( UCSR0A & (1<<UDRE0)));
  UDR0 = data;
}

unsigned char USART_Receive( void ){
while ( !(UCSR0A & (1<<RXC0)) );
return UDR0;
}

int main()
{
  UBRR0H = 0;     //USART
  UBRR0L = 0;     //1 MBaud
  UCSR0B = 0x18;  //TX, RX an
  UCSR0C = 0x06;  //8N1

  TCCR0A = 0x42;  //Timer0 Toggle OC0A
  TCCR0B = 0x00;  //aus
  OCR0A = 255;    // 0 Hz

  TCCR2A = 0xA3;  //Timer2 Fast PWM an PD3/PB3
  TCCR2B = 0x01;  //16 MHz
  TIMSK2 = 0x01;  //Timer0 Overflow Interrupt
  OCR2A = 128;
  OCR2B = 128;

  ADMUX = 0x60;   //Ref = VCC, Left adjusted   
  ADCSRA = 0xC4;  //ADC Enable, Start, 1 MHz
  DIDR0 = 0x03;
  
  TCCR1A = 0x00;
  TCCR1B = 0x07;  //Timer1 Input
  TIMSK1 = 0x01;  //Timer1 Overflow Interrupt
  TCCR1C = 0;
  
  DDRB = 255;
  DDRD = 0xDE; //  254;
  ds1 = 1;
  ds2 = 1;
  ch = 0x60;
  ADMUX = 0x60; 
  
  for (n=0;n<256;n++){
    dds1[n]= 128+127.9*sin(PI*n/128.0);
    dds2[n]= 128+127.9*sin(PI*n/128.0);  
  }

  ph1=1049;  //1 kHz
  ph2=2098;  //2 kHz
  sei();
  
  while(true) {
    c=USART_Receive();
    //cli();
    if (c==65){
      adn=0;     //Oszi Start
    }
    if (c==68){        //Oszi Ablenkteit
     dv = USART_Receive(); 
    } 
    if (c==69){        //Oszi Ch1
      ADMUX = 0x60;
      duo = 0;
      ch = 0x60;
    }
    if (c==70){        //Oszi Ch1+2
      ADMUX = 0x61;
      duo = 1;
      ch = 0x61;
    }
    if (c==71){        //Oszi Ch2
      ADMUX = 0x61;
      duo = 0;
      ch = 0x61;
    }

    if (c==72){   //U-ramp
      ADMUX = 0x60;
      ds1 = 0;
      adn = 0;
      ph1 = 0;
      while (adn<629){
        asm ("nop");
        n = adn;
        OCR2A = (n<<6)/157;   
      }
      ph1=0;
      a1=0;
    }
    if (c==73){   //f-Sweep
      ADMUX = 0x60;
      duo = 0;
      ds1 = 1;
      ch = 0x60;
      adn=0;
      while (adn<629){
        asm ("nop");
        n = adn;
        ph1 = n<<3;   
      }
      ph1=0;
      a1=0;
    }
    
    
    if (c==80){           //DDS Freq 1
      ph1 = USART_Receive()<<8; 
      ph1 = ph1+ USART_Receive(); 
      ds1 = 1;
    }
    if (c==81){           //DDS Freq 2
      ph2 = USART_Receive()<<8; 
      ph2 = ph2+ USART_Receive(); 
      ds2 = 1;
    } 
      
    if (c==82){        //DDS Phase
      a2= (USART_Receive())<<8;
      a1=0x0000;
    }


     if (c==83){        //DC Ch1
      ds1 = 0;
      OCR2A =  USART_Receive();
    }
     if (c==84){        //DC Ch2
      ds2 = 0;
      OCR2B =  USART_Receive();
    }
    if (c==85){        //Sinus 
      for (n=0;n<256;n++)  dds1[n]= 128+127.9*sin(PI*n/128.0);
    }
    if (c==86){        //Sinus /2
      for (n=0;n<256;n++) dds1[n]= 128+64*sin(PI*n/128.0);
    }
    if (c==87){        //Dreieck
      for (n=0;n<128;n++) dds1[n]=  2 * n;
      for (n=128;n<256;n++) dds1[n]= 255 - 2 * (n - 128);
    }
    if (c==88){        //Sägezahn
      for (n=0;n<256;n++) dds1[n]= n;
    }



    
    if (c==75){       //ADC 10 Bit
      ADCSRA =  0x00; //ADC abschalten
      ADCSRA =  0x86; //ADC an Clk / 64
      ADMUX = 0x40 + USART_Receive(); //0x42 für AD2
      ADCSRA =  0xC2;  //1. Start     
      while((ADCSRA & 0x40)); 
      ADCSRA =  0xC2;  //2.Start     
      while((ADCSRA & 0x40)); 
      adc=ADC;
      USART_Transmit(adc>>8);
      USART_Transmit(adc & 0xFF);
      ADCSRA =  0x00; //ADC abschalten
      ADMUX = ch;   //Ref = VCC, Left adjusted   
      ADCSRA = 0xC4;  //ADC Enable, Start, 1, 1 MHz

    }
    if (c==16){       //ADC Ch3
      ADCSRA =  0x00; //ADC abschalten
      ADCSRA =  0x86; //ADC an Clk / 64
      ADMUX = 0x43;   //AD3, right adjust
      ADCSRA =  0xC2;  //1. Start     
      while((ADCSRA & 0x40)); 
      ADCSRA =  0xC2;  //2.Start     
      while((ADCSRA & 0x40)); 
      adc=ADC;
      USART_Transmit(adc>>8);
      USART_Transmit(adc & 0xFF);
      ADCSRA =  0x00; //ADC abschalten
      ADMUX = ch;   //Ref = VCC, Left adjusted   
      ADCSRA = 0xC4;  //ADC Enable, Start, 1, 1 MHz
    }
     if (c==91){       //Timer 1 Frequenz
      USART_Transmit(fh2);
      USART_Transmit(f>>8);
      USART_Transmit(f & 0xFF);    
    }
    if (c==66){     //+Trigger
      level = USART_Receive();
    // sei();
     timeout=0;
      while (ADCH>=level) {timeout++; if(timeout>10000) break;}
      while (ADCH<level) {timeout++; if(timeout>10000) break;}
      adn=0;
    }
    if (c==67){     //-Trigger
      level = USART_Receive();
    //  sei();
      timeout=0;
      while (ADCH<=level) {timeout++; if(timeout>10000) break;}
      while (ADCH>level) {timeout++; if(timeout>10000) break;}
      adn=0;
    }
    if (c==90){     //OC0A Frequenz
      TCCR0B = USART_Receive();
      OCR0A = USART_Receive(); 
    }
    if (c==76){     //CR-Mesung
      DDRC = 0x30;  //C4/C5 output
      PORTC = 0;
      ADCSRA =  0x00; //ADC abschalten
      ADCSRA =  0x86; //ADC an Clk / 64
      ADMUX = 0x44;   //AD4, right adjust
      ADCSRA =  0xC2;  //1. Start          
      while((ADCSRA & 0x40)); //entladen
      for(i=1;i<2000;i++)asm ("nop");
      DDRC &= ~0x10;      //Hi Z
      PORTC |= 0x20;      //C3 an 5V
      for(i=1;i<1000;i++) asm ("nop");    
      ADCSRA =  0xC2;  // C messen    
      while((ADCSRA & 0x40)); 
      adc=ADC;
      USART_Transmit(adc>>8);
      USART_Transmit(adc & 0xFF);
      PORTC = 0x10;     //D3 Pullup, A5 GND
      for(i=1;i<1000;i++) asm ("nop");
      ADCSRA =  0xC2;  //R messen     
      while((ADCSRA & 0x40)); 
      adc=ADC;
      USART_Transmit(adc>>8);
      USART_Transmit(adc & 0xFF);
      DDRC &= ~0x10;      //Hi Z
      PORTC |= 0x20;      //C1, C2 an 5V
      ADCSRA =  0x00; //ADC abschalten
      ADMUX = ch;   //Ref = VCC, Left adjusted   
      ADCSRA = 0xC4;  //ADC Enable, Start, 1, 1 MHz
    }
  }
}
